unit config_form;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  MaskEdit, ExtCtrls, Spin, Buttons, RTTICtrls, param_config;

type

  { TConfigForm }

  TConfigForm = class(TForm)
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    Bevel5: TBevel;
    CanalSpin: TSpinEdit;
    GuardarButton: TBitBtn;
    CancelButton: TBitBtn;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    Image6: TImage;
    LabelChannel: TLabel;
    LabelTemp: TLabel;
    HostNameEdit: TLabeledEdit;
    LabelBatt: TLabel;
    LabelDebug: TLabel;
    BattSpin: TSpinEdit;
    BattTimeSpin: TSpinEdit;
    LabelTemp1: TLabel;
    LabelTemp2: TLabel;
    LabelTemp3: TLabel;
    LabelTemp4: TLabel;
    LabelTemp5: TLabel;
    LabelTemp6: TLabel;
    TempTimeSpin: TSpinEdit;
    TempSpin: TSpinEdit;
    DebugTimeSpin: TSpinEdit;

    procedure CancelButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure GuardarButtonClick(Sender: TObject);

  private
    { private declarations }
  public
    { public declarations }

  end; 

var
  ConfigForm: TConfigForm;

implementation

{$R *.lfm}

{ TConfigForm }
var
oldChannel: Byte;

procedure TConfigForm.CancelButtonClick(Sender: TObject);
begin
  Close;
end;




procedure TConfigForm.FormShow(Sender: TObject);
begin
  HostNameEdit.Text    := Hostname;
  TempTimeSpin.Value   := TEMP_ALARM_SECS;
  TempSpin.Value       := TEMP_ALARM_THRESHOLD;
  BattTimeSpin.Value   := BATT_ALARM_SECS;
  BattSpin.Value       := BATT_ALARM_THRESHOLD;
  DebugTimeSpin.Value  := DEBUG_SECS;
  CanalSpin.Value      := CHANNEL;
  oldChannel           := CHANNEL;
  ChannelHasChanged    := FALSE;
end;

procedure TConfigForm.GuardarButtonClick(Sender: TObject);
begin
  Hostname             := HostNameEdit.Text;
  TEMP_ALARM_SECS      := TempTimeSpin.Value;
  TEMP_ALARM_THRESHOLD := TempSpin.Value;
  BATT_ALARM_SECS      := BattTimeSpin.Value;
  BATT_ALARM_THRESHOLD := BattSpin.Value;
  DEBUG_SECS           := DebugTimeSpin.Value;
  if (oldChannel<> CanalSpin.Value) then
  begin
    ChannelHasChanged := TRUE;
    CHANNEL := CanalSpin.Value;
  end;
end;


end.

