unit main_form;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ComCtrls,
  ExtCtrls, Menus, ActnList, StdCtrls, Buttons, Grids, EditBtn, UniqueInstance,
  uCmdBox, SynEdit, RTTICtrls, RTTIGrids, lNetComponents, lNet, strings,
  strutils, types, config_form, param_config, channel_form, alarm_select_form,
  Windows, DateUtils;

const
  CR = #$0D;
  LF = #$0A;
  ConsoleColorDefault = clLtGray;
  ConsoleColorEvents = clHighlight;
  ConsoleColorIncomingMessage = clLime;
  ConsoleColorOutgoingMessage = clYellow;
  ConsoleColorData = clAqua;
  ConsoleColorInfo = clGray;
  ConsoleColorAlarm = clRed;
  ConsoleColorWarning = clWhite;
  ConsoleColorDebug = clLime;


type

  { TFPrincipal }

  TFPrincipal = class(TForm)
    //    HostEdit: TEditButton;
    DebugCmdLine: TEditButton;
    IDButton: TSpeedButton;
    SDButton: TSpeedButton;
    ADButton: TSpeedButton;
    TimerLimpieza: TTimer;
    x: TMenuItem;
    MenuItem2: TMenuItem;
    PDButton: TSpeedButton;
    DDButton: TSpeedButton;
    CmdBox1: TCmdBox;
    ColIcon: TImageList;
    ColIcon1: TImageList;
    DebugMote: TSpeedButton;
    DebugButtonPanel: TPanel;
    GDButton: TSpeedButton;
    PopupMenu1: TPopupMenu;
    StringGridPopup: TPopupMenu;
    RDButton: TSpeedButton;
    StringGrid1: TStringGrid;
    NDButton: TSpeedButton;
    HDButton: TSpeedButton;
    TCPSocket: TLTCPComponent;
    MoteConfigButton: TSpeedButton;
    MoteConnectButton: TSpeedButton;
    NetworkIcons: TImageList;
    ConnectionIcons: TImageList;
    DebugPanel: TPanel;
    StatusBar: TStatusBar;
    TIcon: TTrayIcon;
    TreeView1: TTreeView;
    UniqueInstance1: TUniqueInstance;
    procedure ADButtonClick(Sender: TObject);
    procedure HDButtonClick(Sender: TObject);
    procedure DDButtonClick(Sender: TObject);
    procedure DebugCmdLineButtonClick(Sender: TObject);
    procedure DebugCmdLineChange(Sender: TObject);
    procedure DebugCmdLineKeyDown(Sender: TObject; var Key: word;
      Shift: TShiftState);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure DebugMoteClick(Sender: TObject);
    procedure DebugMoteMouseEnter(Sender: TObject);
    procedure DebugMoteMouseLeave(Sender: TObject);
    procedure FormWindowStateChange(Sender: TObject);
    procedure GDButtonClick(Sender: TObject);
    procedure IDButtonClick(Sender: TObject);
    procedure MoteConfigButtonClick(Sender: TObject);
    procedure MoteConfigButtonMouseEnter(Sender: TObject);
    procedure MoteConfigButtonMouseLeave(Sender: TObject);
    procedure DebugPanelClick(Sender: TObject);
    procedure PDButtonClick(Sender: TObject);
    procedure RDButtonClick(Sender: TObject);
    procedure SDButtonClick(Sender: TObject);
    procedure ShellTreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure MoteConnectButtonClick(Sender: TObject);
    procedure MoteConnectButtonMouseEnter(Sender: TObject);
    procedure MoteConnectButtonMouseLeave(Sender: TObject);
    procedure StringGrid1DblClick(Sender: TObject);
    procedure StringGrid1PrepareCanvas(Sender: TObject; aCol, aRow: integer;
      aState: TGridDrawState);
    procedure TCPSocketCanSend(aSocket: TLSocket);
    procedure TCPSocketConnect(aSocket: TLSocket);
    procedure TCPSocketDisconnect(aSocket: TLSocket);
    procedure TCPSocketError(const msg: string; aSocket: TLSocket);
    procedure TCPSocketReceive(aSocket: TLSocket);
    procedure NDButtonClick(Sender: TObject);
    procedure TIconDblClick(Sender: TObject);
    procedure TimerLimpiezaTimer(Sender: TObject);
    procedure TreeView1DblClick(Sender: TObject);
    procedure UniqueInstance1OtherInstance(Sender: TObject;
      ParamCount: integer; Parameters: array of string);
    procedure UpdateGrid(alarm: string);
    procedure ClearGrid;
    procedure UpdateMoteList(node, rssi: string; is_root: boolean);
    procedure ClearMoteList;
    procedure DeleteAlarmfromGrid(kind, serial: string);


  private
    { private declarations }
  public
    { public declarations }
  end;

var
  FPrincipal: TFPrincipal;
  MyIcon: TBitmap;
  MyIconIndex: integer = 0;
  ConnectionStringList: TStringList;
  oldHint: string;
  TCPCanWrite: boolean = False;
  AlarmList: TStringList;
  TL_was_running: boolean;

implementation

{$R *.lfm}

{ TFPrincipal }

type
  PTimestamp = ^TDateTime;

procedure TFPrincipal.ShellTreeView1Change(Sender: TObject; Node: TTreeNode);
begin

end;

procedure TFPrincipal.MoteConnectButtonClick(Sender: TObject);
begin
  if (TCPSocket.Host = '') then
  begin
    TCPSocket.Port := TCP_SOCKET_PORT;
    TCPSocket.Host := hostname;
  end;

  if (MyIconIndex = 0) then
  begin
    StatusBar.SimpleText := 'Intentando conectar a ' + TCPSocket.Host;
    CmdBox1.TextColor(ConsoleColorEvents);
    CmdBox1.Writeln('# Socket: Trying to connect to ' + TCPSocket.Host);
    CmdBox1.TextColor(ConsoleColorDefault);
    TCPSocket.Connect;
    MoteConnectButton.Enabled := False;
    MoteConfigButton.Enabled := False;
  end
  else
  begin
    TCPSocket.Disconnect;
  end;

  //  MoteConnectButton.Glyph:=MyIcon;
end;

procedure TFPrincipal.MoteConnectButtonMouseEnter(Sender: TObject);
begin
  StatusBar.SimpleText := ConnectionStringList.Strings[MyIconIndex + 2];
  ConnectionIcons.GetBitmap(MyIconIndex + 2, MoteConnectButton.Glyph);
end;

procedure TFPrincipal.MoteConnectButtonMouseLeave(Sender: TObject);
begin
  StatusBar.SimpleText := ConnectionStringList.Strings[MyIconIndex];
  ConnectionIcons.GetBitmap(MyIconIndex, MoteConnectButton.Glyph);
end;


procedure TFPrincipal.StringGrid1DblClick(Sender: TObject);
var
  FilteredAlarmList: TStringList;
  j: integer;
  cmds: string;
  AlarmSelectForm: TAlarmSelectForm;
  resultado: TModalResult;
  cadena1, cadena2: string;
begin
  FilteredAlarmList := TStringList.Create;
  FilteredAlarmList.StrictDelimiter := True;
  FilteredAlarmList.delimiter := ',';
  AlarmList.BeginUpdate;
  ;


  for j := 0 to AlarmList.Count - 1 do
    if (pos('A', AlarmList.Strings[j]) = 1) then
      FilteredAlarmList.Append(alarmstr2select(AlarmList.Strings[j]));

  AlarmList.EndUpdate;

  if (FilteredAlarmList.Count > 0) then
  begin
    AlarmSelectForm := TAlarmSelectForm.Create(self);

    AlarmSelectForm.ListaAlarmas := TStringList.Create;
    AlarmSelectForm.ListaAlarmas.StrictDelimiter := True;
    AlarmSelectForm.ListaAlarmas.delimiter := ',';
    for j := 0 to FilteredAlarmList.Count - 1 do
      AlarmSelectForm.ListaAlarmas.append(FilteredAlarmList[j]);

    resultado := AlarmSelectForm.ShowModal;
    case resultado of
      mrOk:
      begin
        FilteredAlarmList.Clear;
        FilteredAlarmList.delimiter := '|';
        FilteredAlarmList.DelimitedText := AlarmSelectForm.SelectedString;
        cmds := FilteredAlarmList[0] + FilteredAlarmList[1];
        insert(' ', cmds, 2);
        CmdBox1.TextColor(ConsoleColorOutgoingMessage);
        CmdBox1.writeln(cmds);
        //                  AlarmSelectForm.SelectedString+'"');
        TCPSocket.SendMessage(cmds + LF);
        DeleteAlarmfromGrid(FilteredAlarmList[0], FilteredAlarmList[1]);
      end;
    end;
    AlarmSelectForm.ListaAlarmas.Free;
  end
  else
    ShowMessage('No hay alarmas todavía');
  FilteredAlarmList.Free;

end;


procedure TFPrincipal.StringGrid1PrepareCanvas(Sender: TObject;
  aCol, aRow: integer; aState: TGridDrawState);
begin
  if not (gdfixed in aState) then
    case StringGrid1.Cells[0, aRow] of
      'AT':
      begin
        StringGrid1.Canvas.Brush.Color := clRed;
        StringGrid1.Canvas.Font.Color := clWhite;
      end;
      'AM':
      begin
        StringGrid1.Canvas.Brush.Color := clRed;
        StringGrid1.Canvas.Font.Color := clWhite;
      end;
      'AB':
      begin
        StringGrid1.Canvas.Brush.Color := clRed;
        StringGrid1.Canvas.Font.Color := clWhite;
      end;
    end;
  {
     if StringGrid1.Cells [0,aRow] = 'AT' then
     begin
        StringGrid1.Canvas.Brush.Color := clRed;
        StringGrid1.Canvas.Font.Color := clWhite
    end}
  //else begin
  //      StringGrid1.Canvas.Brush.Color := clWindow;
  //    end;
  //StringGrid1.Cells[aCol,4]:=IntToStr(aRow)+','+IntToStr(aCol)

end;


procedure TFPrincipal.TCPSocketCanSend(aSocket: TLSocket);
var
  cmds: string;
begin
  // Habilitamos los componentes de envio de mensajes
  TCPCanWrite := True;
  DebugButtonPanel.Visible := TCPCanWrite;
  DebugCmdLine.Enabled := TCPCanWrite;
  CmdBox1.TextColor(ConsoleColorEvents);
  CmdBox1.Writeln('# Socket: CanSend');
  CmdBox1.TextColor(ConsoleColorDefault);
  // Mote discovery...
  cmds := 'i' + lf;
  TCPSocket.SendMessage(cmds);
  cmds := 'p' + lf;
  TCPSocket.SendMessage(cmds);
  TimerLimpieza.Enabled := True;
  //  cmds:='p'+cr+lf;
  //  TCPSocket.SendMessage(cmds);

end;

procedure TFPrincipal.TCPSocketConnect(aSocket: TLSocket);
begin
  MyIconIndex := 1;
  StatusBar.SimpleText := ConnectionStringList.Strings[MyIconIndex];
  MoteConnectButton.Hint := ConnectionStringList.Strings[MyIconIndex];
  ConnectionIcons.GetBitmap(MyIconIndex, MoteConnectButton.Glyph);
  MoteConfigButton.Enabled := False;
  CmdBox1.TextColor(ConsoleColorEvents);
  CmdBox1.Writeln('# Socket: Connected to ' + TCPSocket.Host);
  CmdBox1.TextColor(ConsoleColorDefault);
  MoteConnectButton.Enabled := True;
  MoteConfigButton.Enabled := True;
end;

procedure TFPrincipal.TCPSocketDisconnect(aSocket: TLSocket);
var
  Node: TTreeNode;
begin
  TimerLimpieza.Enabled := False;
  MyIconIndex := 0;
  StatusBar.SimpleText := ConnectionStringList.Strings[MyIconIndex];
  MoteConnectButton.Hint := ConnectionStringList.Strings[MyIconIndex];
  ConnectionIcons.GetBitmap(MyIconIndex, MoteConnectButton.Glyph);
  TCPCanWrite := False;
  MoteConfigButton.Enabled := True;
  DebugButtonPanel.Visible := TCPCanWrite;
  DebugCmdLine.Enabled := TCPCanWrite;
  CmdBox1.TextColor(ConsoleColorEvents);
  CmdBox1.Writeln('# Socket: disconnected from ' + TCPSocket.Host);
  CmdBox1.TextColor(ConsoleColorDefault);

  StringGrid1.RowCount := 1;
  TreeView1.BeginUpdate;
  while (TreeView1.Items.Count <> 0) do
  begin
    Node := TreeView1.Items.GetLastNode;
    //PTimestamp
    if (Node.Data <> nil) then
      Freememory(Node.Data, sizeof(TDateTime));
    Node.Delete;
    //if TreeView1.Items.GetFirstNode.HasChildren then
    //begin
    //     Node:=TreeView1.Items.Get
    //     TreeView1.Items.GetFirstNode.DeleteChildren;

    //end else begin
    //   TreeView1.Items.GetFirstNode.Delete;
    //end;
  end;
  AlarmList.Clear;
  TreeView1.EndUpdate;

  // TODO:: borrar el treeview

end;

procedure TFPrincipal.TCPSocketError(const msg: string; aSocket: TLSocket);
var
  Node: TTreeNode;
begin
  TimerLimpieza.Enabled := False;
  TCPCanWrite := False;
  CmdBox1.TextColor(ConsoleColorWarning);
  CmdBox1.Writeln('# Socket: ERROR en la conexión a ' + TCPSocket.Host);
  CmdBox1.TextColor(ConsoleColorDefault);
  DebugButtonPanel.Visible := TCPCanWrite;
  MoteConfigButton.Enabled := True;
  DebugCmdLine.Enabled := TCPCanWrite;
  //  HostEdit.Text:='';
  TCPSocket.Host := '';
  MoteConnectButton.Enabled := True;
  MoteConfigButton.Enabled := True;
  StringGrid1.RowCount := 1;
  TreeView1.BeginUpdate;
  AlarmList.Clear;
  while (TreeView1.Items.Count <> 0) do
  begin
    //   if TreeView1.Items.GetFirstNode.HasChildren then
    //      TreeView1.Items.GetFirstNode.DeleteChildren
    //      else TreeView1.Items.GetFirstNode.Delete;
    Node := TreeView1.Items.GetLastNode;
    if (Node.Data <> nil) then
      Freememory(Node.Data, sizeof(TDateTime));
    Node.Delete;
  end;
  TreeView1.EndUpdate;
end;



procedure TFPrincipal.UpdateGrid(alarm: string);
var
  g_date, g_alrm_kind, g_node, g_value, g_serial, g_rssi, g_alarm_kindnr,
  g_is_alarm: string;
  value_found: boolean;
  j, k: integer;
  ahora: TDateTime;
  pahora: pointer;
  acumm: integer;


begin
  getLineValues(alarm, g_date, g_alrm_kind, g_is_alarm, g_node,
    g_alarm_kindnr, g_value, g_serial, g_rssi);

  // buscamos "ALARMA, NODO" en la lista de alarmas
  UpdateMoteList(g_node, g_rssi, False);
  value_found := False;
  for j := 0 to AlarmList.Count - 1 do
    if (Pos(g_alrm_kind + ',' + g_node, AlarmList.Strings[j]) <> 0) then
    begin
      // lo hemos encontrado
      value_found := True;
      k := j;
    end;

  AlarmList.BeginUpdate;


  if (not value_found) then
    AlarmList.Add(alarmstr2grid(alarm))
  else
    AlarmList.Strings[k] := alarmstr2grid(alarm);

  //     TDateTime
  ahora := now;
  pahora := @ahora;
  //     copymem

      CopyMemory(Treeview1.Items.FindNodeWithText(g_node).Data, pahora,
          sizeof(TDateTime));
  //     Treeview1.Items.FindNodeWithText(g_node).Data^:=ahora;

  AlarmList.EndUpdate;
  StringGrid1.BeginUpdate;
  StringGrid1.RowCount := 1;
  StringGrid1.RowCount := AlarmList.Count + 1;
  for j := 0 to AlarmList.Count - 1 do
    StringGrid1.Rows[j + 1].DelimitedText := AlarmList.Strings[j];
  StringGrid1.SortOrder := soAscending;
  StringGrid1.SortColRow(True, 0);
  StringGrid1.EndUpdate(True);


end;

procedure TFPrincipal.ClearGrid;
begin
  StringGrid1.Clear;
end;

procedure TFPrincipal.UpdateMoteList(node, rssi: string; is_root: boolean);
var
  root_node: TTreeNode;
  ahora: TDateTime;
  pahora: pointer;
begin
  ahora := now;
  pahora := @ahora;
  TreeView1.BeginUpdate;

  if TreeView1.Items.Count = 0 then
  begin
    Treeview1.Items.Add(nil, 'NetWork');
    Treeview1.Items.FindNodeWithText('NetWork').ImageIndex := 6;
    Treeview1.Items.FindNodeWithText('NetWork').Data := AllocMem(sizeof(TDateTime));
    //    CopyMemory(Treeview1.Items.FindNodeWithText('Network').Data, pahora,
    //        sizeof(TDateTime));
  end;

  if (not is_root) then
    if (Treeview1.Items.FindNodeWithText(node) = nil) then
    begin
      root_node := TreeView1.Items.GetFirstNode;
      Treeview1.Items.AddChild(root_node, node);
      Treeview1.Items.FindNodeWithText(node).ImageIndex := 0;
      Treeview1.Items.FindNodeWithText(node).Data := AllocMem(sizeof(TDateTime));
      CopyMemory(Treeview1.Items.FindNodeWithText(node).Data, pahora,
        sizeof(TDateTime));
    end
    else
    begin
      if (TreeView1.Items.GetFirstNode <>
         Treeview1.Items.FindNodeWithText(node)) then
         Treeview1.Items.FindNodeWithText(node).ImageIndex := 0;
    end
  else
  begin
    if (Treeview1.Items.FindNodeWithText(node) <> nil) then
    begin
      if (TreeView1.Items.FindNodeWithText('NetWork') <> nil) then
      begin
        if (Treeview1.Items.FindNodeWithText(node).Data <> nil) then
          Freememory(Treeview1.Items.FindNodeWithText(node).Data,
            sizeof(TDateTime));
        Treeview1.Items.FindNodeWithText(node).Delete;
        TreeView1.Items.FindNodeWithText('NetWork').Text := node;
      end;
    end
    else
      TreeView1.Items.FindNodeWithText('NetWork').Text := node;
  end;
  TreeView1.EndUpdate;
end;

procedure TFPrincipal.ClearMoteList;
begin

end;

procedure TFPrincipal.TCPSocketReceive(aSocket: TLSocket);
type
  MSG_TYPE = (M_NORMAL, M_DB, M_DT, M_AM,
    M_AT, M_AB, M_ID, M_PING,
    M_SETCONF, M_GETCONF, M_BOOT, M_REBOOT,
    M_RECONF, M_DEBUG, M_CHANNEL, M_ACKALRM);
var
  Data: string;
  Lines: TStringList;
  Node: TTreeNode;
  AddtoGrid: boolean;
  g_date, g_alrm_kind, g_node, g_value, g_serial, g_rssi, g_alarm_kindnr,
  g_is_alarm: string;
  msg_kind: MSG_TYPE;
  parsed_line, extracted_data: string;
  togrid: string;
  i: integer;
  cmds: string;
  TL_was_running: boolean;

begin

  TCPSocket.GetMessage(Data);
  Data := StringReplace(Data, CR, '', [rfReplaceAll]);
  Data := StringReplace(Data, #0, '', [rfReplaceAll]);
  CmdBox1.TextColor(ConsoleColorIncomingMessage);
  Lines := TStringList.Create;
  Lines.Clear;
  Lines.StrictDelimiter := True;
  Lines.delimiter := LF;
  Lines.delimitedText := Data;

  for i := 0 to Lines.Count - 1 do
    if (Lines[i] <> '') then
    begin
      parsed_line := Lines[i];
      msg_kind := M_NORMAL;

      {!}     if (Pos('+DB', parsed_line) = 1) then
        msg_kind := M_DB;
      {!}     if (Pos('+DT', parsed_line) = 1) then
        msg_kind := M_DT;
      {!}     if (Pos('+AB', parsed_line) = 1) then
        msg_kind := M_AB;
      {!}     if (Pos('+AT', parsed_line) = 1) then
        msg_kind := M_AT;
      {!}     if (Pos('+AM', parsed_line) = 1) then
        msg_kind := M_AM;
      {!}     if (Pos('+PING', parsed_line) = 1) then
        msg_kind := M_PING;
      {!}     if (Pos('+IAMNODE', parsed_line) = 1) then
        msg_kind := M_ID;
      if (Pos('+BOOT', parsed_line) = 1) then
        msg_kind := M_BOOT;
      if (Pos('+REBOOT', parsed_line) = 1) then
        msg_kind := M_REBOOT;
      if (Pos('+RECONF', parsed_line) = 1) then
        msg_kind := M_RECONF;
      if (Pos('+SETCONF', parsed_line) = 1) then
        msg_kind := M_SETCONF;
      if (Pos('+GETCONF', parsed_line) = 1) then
        msg_kind := M_GETCONF;
      if (Pos('+DEBUG', parsed_line) = 1) then
        msg_kind := M_DEBUG;
      if (Pos('+CHANNEL', parsed_line) = 1) then
        msg_kind := M_CHANNEL;
      if (Pos('+ACKALRM', parsed_line) = 1) then
        msg_kind := M_ACKALRM;

      case msg_kind of
        M_DB: UpdateGrid(parseAlarm(parsed_line));
        M_DT: UpdateGrid(parseAlarm(parsed_line));
        M_AB: UpdateGrid(parseAlarm(parsed_line));
        M_AT: UpdateGrid(parseAlarm(parsed_line));
        M_AM: UpdateGrid(parseAlarm(parsed_line));
        M_GETCONF:
        begin
          ConfLine2UpdateConf(parseConf(parsed_line));
          if TL_was_running then
            TimerLimpieza.Enabled := False;
          TimerLimpieza.Interval := BATT_ALARM_SECS * 1000;
          TimerLimpieza.Enabled := TL_was_running;
        end;
        M_PING:
        begin
          getLineValues(parsePing(parsed_line), g_date,
            g_alrm_kind, g_is_alarm, g_node, g_alarm_kindnr,
            g_value, g_serial, g_rssi);
          //CmdBox1.Writeln('PING: '+g_node+','+g_rssi);
          UpdateMoteList(g_node, g_rssi, False);
        end;
        M_ID:
        begin
          //CmdBox1.Writeln('RootNode: '+parseIAMNODE(parsed_line));
          UpdateMoteList(parseIAMNODE(parsed_line), '0000', True);
        end;
        M_BOOT:
        begin
          cmds := 'i';
          TCPSocket.SendMessage(cmds + LF);
          cmds := 'p';
          TCPSocket.SendMessage(cmds + LF);
          cmds := 'S' + hexStr(TEMP_ALARM_SECS, 4) +
            hexStr(TEMP_ALARM_THRESHOLD, 4) +
            hexStr(BATT_ALARM_SECS, 4) +
            hexStr(BATT_ALARM_THRESHOLD, 4);
          CmdBox1.Writeln(cmds);
          TCPSocket.SendMessage(cmds + LF);
          TL_was_running := TimerLimpieza.Enabled;
          if TL_was_running then
            TimerLimpieza.Enabled := False;
          TimerLimpieza.Interval := BATT_ALARM_SECS * 1000;
          TimerLimpieza.Enabled := TL_was_running;
        end;
        M_REBOOT:
        begin
          AlarmList.BeginUpdate;
          AlarmList.Clear;
          AlarmList.EndUpdate;
          StringGrid1.BeginUpdate;
          StringGrid1.Clear;
          StringGrid1.SortOrder := soAscending;
          StringGrid1.SortColRow(True, 0);
          StringGrid1.EndUpdate(True);
          TreeView1.BeginUpdate;
          while (TreeView1.Items.Count <> 0) do
          begin
            Node := TreeView1.Items.GetLastNode;
            if (Node.Data <> nil) then
              Freememory(Node.Data, sizeof(TDateTime));
            Node.Delete;
          end;
          TreeView1.EndUpdate;
        end;

      end;
      CmdBox1.TextColor(ConsoleColorDebug);
      if msg_kind in [M_AB, M_AM, M_AT, M_ACKALRM] then
        CmdBox1.TextColor(ConsoleColorAlarm)
      else if (msg_kind = M_NORMAL) then
        CmdBox1.TextColor(ConsoleColorInfo)
      else
        CmdBox1.TextColor(ConsoleColorData);
      CmdBox1.Writeln(parsed_line);

    end;
  Lines.Free;
  CmdBox1.TextColor(ConsoleColorDefault);
end;

procedure TFPrincipal.NDButtonClick(Sender: TObject);
var
  cmds: string;
  ChannelForm: TChannelForm;
  resultado: TModalResult;

begin
  ChannelForm := TChannelForm.Create(self);
  resultado := ChannelForm.ShowModal;
  case resultado of
    mrOk:
    begin
      if (ChannelHasChanged and TCPCanWrite) then
      begin
        CmdBox1.TextColor(ConsoleColorOutgoingMessage);
        CmdBox1.writeln('Channel changed: ' + IntToStr(Channel) +
          ' (0x' + hexStr(CHANNEL, 2) + ')');
        cmds := 'n ' + IntToStr(CHANNEL);
        TCPSocket.SendMessage(cmds + lf);
      end;
    end;
  end;
end;


procedure TFPrincipal.TIconDblClick(Sender: TObject);
begin
  FPrincipal.WindowState := wsNormal;
  FPrincipal.Show;
  FPrincipal.ShowInTaskBar := stAlways;
  TIcon.Visible := False;
end;



procedure TFPrincipal.TimerLimpiezaTimer(Sender: TObject);
var
  Node: TTreeNode;
  i, j, k, l: integer;
  lastupdate: PTimestamp;
  recordedtime: TDateTime;
  recordedtimeplus: TDateTime;
  Alarm: TStringList;
  c1, c2, c3, c4: string;

begin

  Alarm := TStringList.Create;
  Alarm.delimiter := ',';
  Alarm.StrictDelimiter := True;
  AlarmList.BeginUpdate;
  for i := TreeView1.Items.Count - 1 downto 1 do
    // borramos los nodos hijos excepto el de conexion
  begin
    Node := TreeView1.Items[i];
    if (Node.Data <> nil) then
    begin
      lastupdate := Node.Data;
      recordedtime := lastupdate^;
      recordedtimeplus :=
        IncSecond(recordedtime, BATT_ALARM_SECS);
      CmdBox1.Writeln('>> '+FormatDateTime('YYYYMMDD hh:nn:ss,', now)+
        ' Ultima actualización del nodo ' + Node.Text +
        ': ' + FormatDateTime('YYYYMMDD hh:nn:ss,', recordedtime));
      if (CompareDateTime(now, recordedtimeplus) > 0) then
      begin
        CmdBox1.Write('>> ' + Node.Text + ' debe borrarse...');
        Alarm.Clear;
        for j := AlarmList.Count - 1 downto 0 do
        begin
          Alarm.delimitedText := AlarmList.Strings[j];
          if (Alarm[1] = Node.Text) then
            AlarmList.Delete(j);
        end;
        Node.Delete;
        CmdBox1.Writeln(' borrado!');
      end;
    end;

  end;
  AlarmList.EndUpdate;

  StringGrid1.BeginUpdate;
  StringGrid1.RowCount := 1;
  StringGrid1.RowCount := AlarmList.Count + 1;

{     for j:=0 to AlarmList.Count-1 do
        StringGrid1.Rows[j+1].DelimitedText:=AlarmList.Strings[j];
}

  for j := 0 to AlarmList.Count - 1 do
  begin
    StringGrid1.Rows[j + 1].DelimitedText := AlarmList.Strings[j];
  end;
  StringGrid1.SortOrder := soAscending;
  StringGrid1.SortColRow(True, 0);
  StringGrid1.EndUpdate(True);
  Alarm.Free;

end;

procedure TFPrincipal.TreeView1DblClick(Sender: TObject);
var
  cmds: string;
  ConfigForm: TConfigForm;
  resultado: TModalResult;
begin

  ConfigForm := TConfigForm.Create(self);
  resultado := ConfigForm.ShowModal;
  case resultado of
    mrOk:
    begin
      if tcpcanwrite then
      begin
        if (ChannelHasChanged) then
        begin
          CmdBox1.TextColor(ConsoleColorOutgoingMessage);
          CmdBox1.writeln('Channel changed: ' + IntToStr(Channel) +
            ' (0x' + hexStr(CHANNEL, 2) + ')');
          cmds := 'n ' + IntToStr(CHANNEL) + lf;
          TCPSocket.SendMessage(cmds);
        end;
        cmds := 'S' + hexStr(TEMP_ALARM_SECS, 4) +
          hexStr(TEMP_ALARM_THRESHOLD, 4) +
          hexStr(BATT_ALARM_SECS, 4) + hexStr(BATT_ALARM_THRESHOLD, 4);
        CmdBox1.TextColor(ConsoleColorOutgoingMessage);
        CmdBox1.writeln('Sending newConf: ' + cmds);
        TCPSocket.SendMessage(cmds + LF);

        TL_was_running := TimerLimpieza.Enabled;
        if TL_was_running then
          TimerLimpieza.Enabled := False;
        TimerLimpieza.Interval := BATT_ALARM_SECS * 1000;
        TimerLimpieza.Enabled := TL_was_running;
      end;
    end;
  end;

end;



procedure TFPrincipal.UniqueInstance1OtherInstance(Sender: TObject;
  ParamCount: integer; Parameters: array of string);
begin
  ShowMessage('El programa ya está en ejecución');
  //Application.MessageBox ('El programa ya está en ejecución',
  //                          'Proceso duplicado', MB_ICONEXCLAMATION );


  Exit;
end;


procedure TFPrincipal.FormCreate(Sender: TObject);
var

  Lst: TStringList;

begin

  ReadIniFile;
  CmdBox1.AutoFollow := True;
  ;
  FPrincipal.Width := 420;
  FPrincipal.Height := 370;
  FPrincipal.Caption := 'Mote control';
  ConnectionStringList := TStringList.Create;
  ConnectionStringList.Duplicates := dupIgnore;
  ConnectionStringList.Add('Desconectado del mote');
  ConnectionStringList.Add('Conectado al mote');
  ConnectionStringList.Add('Conectar al mote');
  ConnectionStringList.Add('Desconectar del mote');
  StatusBar.SimpleText := ConnectionStringList.Strings[MyIconIndex];
  ConnectionIcons.GetBitmap(MyIconIndex, MoteConnectButton.Glyph);
  //     ConnectPanel.Visible:=False;
  CmdBox1.TextColors(clLime, clBlack);
  DebugButtonPanel.Visible := TCPCanWrite;
  DebugCmdLine.Enabled := TCPCanWrite;
  AlarmList := TStringList.Create;
  AlarmList.StrictDelimiter := True;
  AlarmList.Delimiter := ',';
end;

procedure TFPrincipal.DeleteAlarmfromGrid(kind, serial: string);
var
  alarm_index_to_delete: integer;
  i, j: integer;
begin
  alarm_index_to_delete := -1;
  for i := 0 to AlarmList.Count - 1 do
  begin
    //CmdBox1.Writeln(AlarmList.Strings[i]);
    if ((Pos(kind + ',', AlarmList.Strings[i]) = 1) and
      (Pos(',' + serial + ',', AlarmList.Strings[i]) <> 0)) then

      alarm_index_to_delete := i;
  end;
  if (alarm_index_to_delete <> -1) then
  begin
    //CmdBox1.Writeln('found alarm '+g_serial+' of type '+alarm_kind+
    //  ' on position '+IntToStr(alarm_index_to_delete));
    AlarmList.BeginUpdate;
    AlarmList.Delete(alarm_index_to_delete);
    AlarmList.EndUpdate;

    StringGrid1.BeginUpdate;
    StringGrid1.RowCount := 1;
    StringGrid1.RowCount := AlarmList.Count + 1;
    for j := 0 to AlarmList.Count - 1 do
      StringGrid1.Rows[j + 1].DelimitedText := AlarmList.Strings[j];
    StringGrid1.SortOrder := soAscending;
    StringGrid1.SortColRow(True, 0);
    StringGrid1.EndUpdate(True);
  end;
end;


procedure TFPrincipal.DebugCmdLineKeyDown(Sender: TObject; var Key: word;
  Shift: TShiftState);
var
  line: string;
  g_serial: string;
  alarm_acked: boolean;
  alarm_kind: string;
  i, j: integer;

  parsed_line: string;
begin

  if key = 13 then
  begin
    /// TODO
    line := upcase(StringReplace(DebugCmdLine.Text, ' ', '', [rfReplaceAll]));

    alarm_acked := False;

    if (Pos('AM', Line) = 1) then
    begin
      g_serial := MidStr(Line, 3, 4);
      CmdBox1.Writeln('>>> manual alarm serial acked: ' + g_serial);
      alarm_acked := True;
      alarm_kind := 'AM';
    end;
    if (Pos('AB', Line) = 1) then
    begin
      g_serial := MidStr(Line, 3, 4);
      CmdBox1.Writeln('>>> batt alarm serial acked: ' + g_serial);
      alarm_acked := True;
      alarm_kind := 'AB';
    end;
    if (Pos('AT', Line) = 1) then
    begin
      g_serial := MidStr(Line, 3, 4);
      CmdBox1.Writeln('>>> temp alarm serial acked: ' + g_serial);
      alarm_acked := True;
      alarm_kind := 'AT';
    end;

    parsed_line := DebugCmdLine.Text;
    if (Pos('D', Line) = 1) then
    begin
      parsed_line := 'D ' + hexStr(DEBUG_SECS, 4);
      CmdBox1.Writeln('>>> detected debug command; sending param' + Line);
    end;
    CmdBox1.TextColor(ConsoleColorOutgoingMessage);
    CmdBox1.Writeln('# CmdLine Enter KEY, Sending Socket: >' +
      parsed_line + '<');
    CmdBox1.TextColor(ConsoleColorDefault);
    TCPSocket.SendMessage(parsed_line + LF);
    DebugCmdLine.Text := '';
    if (alarm_acked) then
    begin
      DeleteAlarmfromGrid(alarm_kind, g_serial);
      for i := 0 to AlarmList.Count - 1 do
      begin
        CmdBox1.Writeln('>> ' + AlarmList.Strings[i]);
      end;

    end;
  end;

end;

procedure TFPrincipal.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  if TCPSocket.Connected then
    TCPSocket.Disconnect;
  WriteIniFile();
  AlarmList.Free;
end;


procedure TFPrincipal.HDButtonClick(Sender: TObject);
begin
  CmdBox1.TextColor(ConsoleColorOutgoingMessage);
  CmdBox1.Writeln('# Socket: Enviando H command');
  CmdBox1.TextColor(ConsoleColorDefault);
  TCPSocket.SendMessage('H' + LF);
end;

procedure TFPrincipal.ADButtonClick(Sender: TObject);
var
  FilteredAlarmList: TStringList;
  j: integer;
  cmds: string;
  AlarmSelectForm: TAlarmSelectForm;
  resultado: TModalResult;
  cadena1, cadena2: string;
begin
  FilteredAlarmList := TStringList.Create;
  FilteredAlarmList.StrictDelimiter := True;
  FilteredAlarmList.delimiter := ',';
  AlarmList.BeginUpdate;
  ;


  for j := 0 to AlarmList.Count - 1 do
    if (pos('A', AlarmList.Strings[j]) = 1) then
      FilteredAlarmList.Append(alarmstr2select(AlarmList.Strings[j]));

  AlarmList.EndUpdate;

  if (FilteredAlarmList.Count > 0) then
  begin
    AlarmSelectForm := TAlarmSelectForm.Create(self);

    AlarmSelectForm.ListaAlarmas := TStringList.Create;
    AlarmSelectForm.ListaAlarmas.StrictDelimiter := True;
    AlarmSelectForm.ListaAlarmas.delimiter := ',';
    for j := 0 to FilteredAlarmList.Count - 1 do
      AlarmSelectForm.ListaAlarmas.append(FilteredAlarmList[j]);

    resultado := AlarmSelectForm.ShowModal;
    case resultado of
      mrOk:
      begin
        FilteredAlarmList.Clear;
        FilteredAlarmList.delimiter := '|';
        FilteredAlarmList.DelimitedText := AlarmSelectForm.SelectedString;
        cmds := FilteredAlarmList[0] + FilteredAlarmList[1];
        insert(' ', cmds, 2);
        CmdBox1.TextColor(ConsoleColorOutgoingMessage);
        CmdBox1.writeln(cmds);
        //                  AlarmSelectForm.SelectedString+'"');
        TCPSocket.SendMessage(cmds + LF);
        DeleteAlarmfromGrid(FilteredAlarmList[0], FilteredAlarmList[1]);
      end;
    end;
    AlarmSelectForm.ListaAlarmas.Free;
  end
  else
    ShowMessage('No hay alarmas todavía');
  FilteredAlarmList.Free;

end;


procedure TFPrincipal.DDButtonClick(Sender: TObject);
begin
  CmdBox1.TextColor(ConsoleColorOutgoingMessage);
  CmdBox1.Writeln('# Socket: Enviando D command');
  CmdBox1.TextColor(ConsoleColorDefault);
  TCPSocket.SendMessage('D' + hexStr(DEBUG_SECS, 4) + LF);
end;

procedure TFPrincipal.DebugCmdLineButtonClick(Sender: TObject);
begin
  CmdBox1.TextColor(ConsoleColorOutgoingMessage);
  CmdBox1.Writeln('# CmdLine BtnClick, Sending Socket: >' +
    DebugCmdLine.Text + '<');
  CmdBox1.TextColor(ConsoleColorDefault);
  TCPSocket.SendMessage(DebugCmdLine.Text + LF);
  DebugCmdLine.Text := '';
end;

procedure TFPrincipal.DebugCmdLineChange(Sender: TObject);
begin

end;

procedure TFPrincipal.DebugMoteClick(Sender: TObject);
begin
  DebugMote.Down := True;
  DebugPanel.Visible := not (DebugPanel.Visible);
  if DebugPanel.Visible then
    FPrincipal.Width := 980
  else
    FPrincipal.Width := 420;
end;

procedure TFPrincipal.DebugMoteMouseEnter(Sender: TObject);
begin
  oldHint := StatusBar.SimpleText;
  StatusBar.SimpleText := 'Activar debug';
end;

procedure TFPrincipal.DebugMoteMouseLeave(Sender: TObject);
begin
  StatusBar.SimpleText := oldHint;
end;

procedure TFPrincipal.FormWindowStateChange(Sender: TObject);
begin
  if FPrincipal.WindowState = wsMinimized then
  begin
    TIcon.Visible := True;
    FPrincipal.WindowState := wsNormal;
    FPrincipal.Hide;
    FPrincipal.ShowInTaskBar := stNever;
  end;
end;

procedure TFPrincipal.GDButtonClick(Sender: TObject);
begin
  CmdBox1.TextColor(ConsoleColorOutgoingMessage);
  CmdBox1.Writeln('# Socket: Enviando G command');
  CmdBox1.TextColor(ConsoleColorDefault);
  TCPSocket.SendMessage('G' + LF);
end;

procedure TFPrincipal.IDButtonClick(Sender: TObject);
begin
  CmdBox1.TextColor(ConsoleColorOutgoingMessage);
  CmdBox1.Writeln('# Socket: Enviando I command');
  CmdBox1.TextColor(ConsoleColorDefault);
  TCPSocket.SendMessage('I' + LF);
end;

procedure TFPrincipal.MoteConfigButtonClick(Sender: TObject);
var
  cmds: string;
  ConfigForm: TConfigForm;
  resultado: TModalResult;
begin

  ConfigForm := TConfigForm.Create(self);
  resultado := ConfigForm.ShowModal;
  case resultado of
    mrOk:
    begin
      if tcpcanwrite then
      begin
        if (ChannelHasChanged) then
        begin
          CmdBox1.TextColor(ConsoleColorOutgoingMessage);
          CmdBox1.writeln('Channel changed: ' + IntToStr(Channel) +
            ' (0x' + hexStr(CHANNEL, 2) + ')');
          cmds := 'n ' + IntToStr(CHANNEL) + lf;
          TCPSocket.SendMessage(cmds);
        end;
        cmds := 'S' + hexStr(TEMP_ALARM_SECS, 4) +
          hexStr(TEMP_ALARM_THRESHOLD, 4) +
          hexStr(BATT_ALARM_SECS, 4) + hexStr(BATT_ALARM_THRESHOLD, 4);
        CmdBox1.TextColor(ConsoleColorOutgoingMessage);
        CmdBox1.writeln('Sending newConf: ' + cmds);
        TCPSocket.SendMessage(cmds + LF);

        TL_was_running := TimerLimpieza.Enabled;
        if TL_was_running then
          TimerLimpieza.Enabled := False;
        TimerLimpieza.Interval := BATT_ALARM_SECS * 1000;
        TimerLimpieza.Enabled := TL_was_running;
      end;
    end;
  end;
end;

procedure TFPrincipal.MoteConfigButtonMouseEnter(Sender: TObject);
begin
  oldHint := StatusBar.SimpleText;
  StatusBar.SimpleText := 'Configurar conexión';
end;

procedure TFPrincipal.MoteConfigButtonMouseLeave(Sender: TObject);
begin
  StatusBar.SimpleText := oldHint;
end;

procedure TFPrincipal.DebugPanelClick(Sender: TObject);
begin

end;

procedure TFPrincipal.PDButtonClick(Sender: TObject);
begin
  CmdBox1.TextColor(ConsoleColorOutgoingMessage);
  CmdBox1.Writeln('# Socket: Enviando P command');
  CmdBox1.TextColor(ConsoleColorDefault);
  TCPSocket.SendMessage('P' + LF);
end;

procedure TFPrincipal.RDButtonClick(Sender: TObject);
begin
  CmdBox1.TextColor(ConsoleColorOutgoingMessage);
  CmdBox1.Writeln('# Socket: Enviando R command');
  CmdBox1.TextColor(ConsoleColorDefault);
  TCPSocket.SendMessage('R' + LF);
end;

procedure TFPrincipal.SDButtonClick(Sender: TObject);
var
  cmds: string;
begin
  CmdBox1.TextColor(ConsoleColorOutgoingMessage);
  CmdBox1.Write('# Socket: Enviando S command: ');
  CmdBox1.TextColor(ConsoleColorDefault);
  cmds := 'S' + hexStr(TEMP_ALARM_SECS, 4) + hexStr(
    TEMP_ALARM_THRESHOLD, 4) + hexStr(BATT_ALARM_SECS, 4) +
    hexStr(BATT_ALARM_THRESHOLD, 4);
  CmdBox1.Writeln(cmds);
  TCPSocket.SendMessage(cmds + LF);

  TL_was_running := TimerLimpieza.Enabled;
  if TL_was_running then
    TimerLimpieza.Enabled := False;
  TimerLimpieza.Interval := BATT_ALARM_SECS * 1000;
  TimerLimpieza.Enabled := TL_was_running;
end;


end.

