 /* vi: set number syntax=c ruler smartindent autoindent tabstop=8 shiftwidth=8 : */
#ifndef MSG_DEF_H
#define MSG_DEF_H
/* Define unused AM ID on Unreserved pool (0x80 - 0xFF)
 * see tep4.html
 *
 * abbrev. used in AM names
 * 	AM PREFIX:	Active Message
 * 	CS/SC:	Message direction
 * 		Controller->Sensor
 * 		Sensor->Controller
 * 	B/U/X:	Message dest. spread Bcast/Ucast/Both
 *
 */
enum { MAX_TRIES = 3 };
enum {
	AM_CSB_CONFIG = 0x80,
	AM_SCX_ASK_CONFIG,
	AM_SCX_ALARM,
	AM_SCX_BALARM,
	AM_SCX_DEBUG,
	AM_CSX_ALIVE
};

enum {
	DATA_TEMP	=1,
	DATA_BATT	=2,
	DATA_DEBUG	=3,
	ALRM_TEMP	=4,
	ALRM_BATT	=5,
	ALRM_MANUAL	=6,
	ALRM_TEMP_ACK	=7,
	ALRM_BATT_ACK	=8,
	ALRM_MANUAL_ACK	=9,
	CMD_REBOOT	=0x88,
	CMD_PING	=0x99,
	UNK		=0
};

typedef nx_struct CSB_CONFIG {
	nx_uint16_t	channel;
	nx_uint16_t	nodeid;
	nx_uint16_t	temp_alarm_s;
	nx_uint16_t	temp_alarm_threshold;
	nx_uint16_t	batt_alarm_s;
	nx_uint16_t	batt_alarm_threshold;
} CSB_CONFIG;

typedef nx_struct SCX_ASK_CONFIG {
	nx_uint16_t	dst_nodeid;
	nx_uint16_t	orig_nodeid;
} SCX_ASK_CONFIG;

typedef nx_union alarm_param {
	nx_uint16_t	temp_level;
	nx_uint16_t	batt_level;
	nx_uint16_t	temp_debug_s;
	nx_uint16_t	dummy;
} alarm_param;

typedef nx_struct SCX_ALARM {
	nx_bool		is_alarm;
	nx_uint16_t	nodeid;
	nx_uint8_t	alarm_kind;
	alarm_param	param;
	nx_uint16_t	counter;
} SCX_ALARM;

#endif
